// John Clavin -- June 2015
// Algorithm for 5 balls with no active randomness.
// First - ball mode, then - line mode

motionBall[] motionBalls;
color[] fiveColors;
int frameCounter;
int cC; // colorCounter
float radius;
float locX1 = 0;
float locX2 = 300;
float locX3 = 600;
float locX4 = 0;
float locX5 = 300;
float locX6 = 600;
float locY1 = 0;
float locY2 = 0;
float locY3 = 0;
float locY4 = 300;
float locY5 = 300;
float locY6 = 300;

void setup() {
  size(900, 600);
  frameRate(40);
  background(200);
  frameCounter = 0;
  noStroke();
  fiveColors = new color[5];
  for (int h = 0; h < 5; h++) {
    fiveColors[h] = color(random(180), random(180), random(100));
  }
  motionBalls = new motionBall[30];
  cC = 0;
  for (int i = 0; i < 5; i++) {
    motionBalls[i] = new motionBall(locX1, locY1, fiveColors[cC]);
    cC++;
  }
  cC = 0;
  for (int i = 5; i < 10; i++) {
    motionBalls[i] = new motionBall(locX2, locY2, fiveColors[cC]);
    cC++;
  }
  cC = 0;
  for (int i = 10; i < 15; i++) {
    motionBalls[i] = new motionBall(locX3, locY3, fiveColors[cC]);
    cC++;
  }
  cC = 0;
  for (int i = 15; i < 20; i++) {
    motionBalls[i] = new motionBall(locX4, locY4, fiveColors[cC]);
    cC++;
  }
  cC = 0;
  for (int i = 20; i < 25; i++) {
    motionBalls[i] = new motionBall(locX5, locY5, fiveColors[cC]);
    cC++;
  }
  cC = 0;
  for (int i = 25; i < 30; i++) {
    motionBalls[i] = new motionBall(locX6, locY6, fiveColors[cC]);
    cC++;
  }
}

void draw() {
  if (frameCounter > 2300)
    noLoop();
  if (frameCounter < 400)
    background(200);
  for (int j = 0; j < 30; j++) {
    motionBalls[j].action();
  }
  if (frameCounter < 397)
    radius = 14.0;
  else
    radius = 3.0;
  frameCounter++;
}

class motionBall {
  boolean positiveX;
  boolean positiveY;
  boolean speedUpX;
  boolean speedUpY;
  color c;
  float speedX;
  float speedY;
  float speedRateUpX;
  float speedRateDnX;
  float speedRateUpY;
  float speedRateDnY;
  float x;
  float y;
  float locX;
  float locY;

  motionBall(float _locX, float _locY, color _c) {
    locX = _locX;
    locY = _locY;
    c = _c;
    x = random((locX + 20), (locX + 280));
    y = random((locY + 20), (locY + 280));
    speedX = random(0.4, 2.0);
    speedY = random(0.4, 2.0);
    speedRateUpX = random(.05, 0.10);
    speedRateDnX = random(.05, 0.10);
    speedRateUpY = random(.05, 0.10);
    speedRateDnY = random(.05, 0.10);
    if ((int)random(100) < 50)
      positiveX = true;
    else
      positiveX = false;
    if ((int)random(100) < 50)
      positiveY = true;
    else
      positiveY = false; 
    if ((int)random(100) < 50)
      speedUpX = true;
    else
      speedUpX = false;
    if ((int)random(100) < 50)
      speedUpY = true;
    else
      speedUpY = false;
  }

  void action() {
    speedChange();
    if (positiveX) {
      if (x >= (locX + 294))
        positiveX = false;
      else
        x = x + speedX;
    } else {
      if (x <= (locX + 6))
        positiveX = true;
      else
        x = x - speedX;
    }
    if (positiveY) {
      if (y >= (locY + 294))
        positiveY = false;
      else
        y = y + speedY;
    } else {
      if (y <= (locY + 6))
        positiveY = true;
      else
        y = y - speedY;
    }
    fill(c);
    ellipse(x, y, radius, radius);
  }
  void speedChange() {
    if (speedUpX) {
      if (speedX >= 2.5)
        speedUpX = false;
      else
        speedX = speedX + speedRateUpX;
    } else {
      if (speedX <= 0.2)
        speedUpX = true;
      else
        speedX = speedX - speedRateDnX;
    }
    if (speedUpY) {
      if (speedY >= 2.5)
        speedUpY = false;
      else
        speedY = speedY + speedRateUpY;
    } else {
      if (speedY <= 0.2)
        speedUpY = true;
      else
        speedY = speedY - speedRateDnY;
    }
  }
}


